;  Petra Fuzzy Development System File
;  Developed by Control System Laboratory's Team
;  Copyright Control System Laboratory 1998
;  File Name = dataf.ASM
;  Created for PetraFuz FIS Kernel Engine Only
;  This code is generated for MCS51 Family
;  FIS Kernel source code is available for USD 50
;  Please contact : petrafuz@peter.petra.ac.id

;VERSION    EQU 1.0
NUMINP      EQU 02H
NUMOUT      EQU 01H

                ;.CODE
		CSEG
                ORG 4100H
INPUT_MFS:   ;Input Membership Functions
IN0MF:       ;error
            DB 000H,0FFH,02AH,006H  ;nb
            DB 02AH,006H,055H,006H  ;ns
            DB 055H,006H,080H,006H  ;z
            DB 080H,006H,0AAH,006H  ;ps
            DB 0AAH,006H,0FFH,0FFH  ;pb
            DB 000H,000H,000H,000H  ;
            DB 000H,000H,000H,000H  ;
            DB 000H,000H,000H,000H  ;

IN1MF:       ;derror
            DB 000H,0FFH,02AH,006H  ;nb
            DB 02AH,006H,055H,006H  ;ns
            DB 055H,006H,080H,006H  ;z
            DB 080H,006H,0AAH,006H  ;ps
            DB 0AAH,006H,0FFH,0FFH  ;pb
            DB 000H,000H,000H,000H  ;
            DB 000H,000H,000H,000H  ;
            DB 000H,000H,000H,000H  ;

                ;.CODE
                ORG 41A0H
OUTPUT_MFS:  ;Output Membership Functions
OUT0MF:      ;pwm
            DB 000H                    ;nb
            DB 02AH                    ;nm
            DB 055H                    ;ns
            DB 080H                    ;z
            DB 0AAH                    ;ps
            DB 0D5H                    ;pm
            DB 0FFH                    ;pb
            DB 000H                    ;

                ;.CODE
                ORG 41B8H
RULE_START:  DB 000H                    ;IF error IS nb
            DB 008H                    ;AND derror IS nb
            DB 080H                    ;THEN pwm IS nb

            DB 000H                    ;IF error IS nb
            DB 009H                    ;AND derror IS ns
            DB 081H                    ;THEN pwm IS nm

            DB 000H                    ;IF error IS nb
            DB 00AH                    ;AND derror IS z
            DB 081H                    ;THEN pwm IS nm

            DB 000H                    ;IF error IS nb
            DB 00BH                    ;AND derror IS ps
            DB 080H                    ;THEN pwm IS nb

            DB 000H                    ;IF error IS nb
            DB 00CH                    ;AND derror IS pb
            DB 080H                    ;THEN pwm IS nb

            DB 001H                    ;IF error IS ns
            DB 008H                    ;AND derror IS nb
            DB 082H                    ;THEN pwm IS ns

            DB 001H                    ;IF error IS ns
            DB 009H                    ;AND derror IS ns
            DB 081H                    ;THEN pwm IS nm

            DB 001H                    ;IF error IS ns
            DB 00AH                    ;AND derror IS z
            DB 080H                    ;THEN pwm IS nb

            DB 001H                    ;IF error IS ns
            DB 00BH                    ;AND derror IS ps
            DB 080H                    ;THEN pwm IS nb

            DB 001H                    ;IF error IS ns
            DB 00CH                    ;AND derror IS pb
            DB 080H                    ;THEN pwm IS nb

            DB 002H                    ;IF error IS z
            DB 008H                    ;AND derror IS nb
            DB 084H                    ;THEN pwm IS ps

            DB 002H                    ;IF error IS z
            DB 009H                    ;AND derror IS ns
            DB 085H                    ;THEN pwm IS pm

            DB 002H                    ;IF error IS z
            DB 00AH                    ;AND derror IS z
            DB 083H                    ;THEN pwm IS z

            DB 002H                    ;IF error IS z
            DB 00BH                    ;AND derror IS ps
            DB 082H                    ;THEN pwm IS ns

            DB 002H                    ;IF error IS z
            DB 00CH                    ;AND derror IS pb
            DB 081H                    ;THEN pwm IS nm

            DB 003H                    ;IF error IS ps
            DB 008H                    ;AND derror IS nb
            DB 084H                    ;THEN pwm IS ps

            DB 003H                    ;IF error IS ps
            DB 009H                    ;AND derror IS ns
            DB 084H                    ;THEN pwm IS ps

            DB 003H                    ;IF error IS ps
            DB 00AH                    ;AND derror IS z
            DB 085H                    ;THEN pwm IS pm

            DB 003H                    ;IF error IS ps
            DB 00BH                    ;AND derror IS ps
            DB 085H                    ;THEN pwm IS pm

            DB 003H                    ;IF error IS ps
            DB 00CH                    ;AND derror IS pb
            DB 086H                    ;THEN pwm IS pb

            DB 004H                    ;IF error IS pb
            DB 008H                    ;AND derror IS nb
            DB 084H                    ;THEN pwm IS ps

            DB 004H                    ;IF error IS pb
            DB 009H                    ;AND derror IS ns
            DB 085H                    ;THEN pwm IS pm

            DB 004H                    ;IF error IS pb
            DB 00AH                    ;AND derror IS z
            DB 086H                    ;THEN pwm IS pb

            DB 004H                    ;IF error IS pb
            DB 00BH                    ;AND derror IS ps
            DB 086H                    ;THEN pwm IS pb

            DB 004H                    ;IF error IS pb
            DB 00CH                    ;AND derror IS pb
            DB 086H                    ;THEN pwm IS pb

END_OF_RULE: DB 0FFH
