unit tscom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SerialNG, CPort, Buttons, CPortCtl;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    ComPort1: TComPort;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    BitBtn4: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComPort1RxChar(Sender: TObject; Count: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormActivate(Sender: TObject);
begin
        comport1.Connected:=true;       {Aktifkan Serial}
        comport1.SetDTR(false);         {buat Pin DTR menjadi High}
        sleep(150);
        comport1.SetDTR(true);          {buat Pin DTR menjadi High}
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        comport1.Connected:=false;      {Matikan Serial}
end;

procedure TForm1.ComPort1RxChar(Sender: TObject; Count: Integer);
var test : string;
    data1,data2 : integer;
begin
                comport1.ReadStr(test,2);       {Baca buffer sebanyak 2 byte lalu masukkan ke variabel test}
                data1:=ord(test[1]);            {pecah string dari test menjadi 2 yaitu data1 dan data2 }
                data2:=ord(test[2]);
                if data2=1 then data2:=256
                else data2:=0;
                edit1.Text:=inttostr(data1+data2); {tampilkan ke edit box}
end;
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
        comport1.Connected:=true;
        comport1.SetDTR(false);
        sleep(150);
        comport1.SetDTR(true);
        edit1.Text:='0';
        form1.Caption:='DT-51 Petra Fuzz [Running ...]';
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
        comport1.Connected:=false;              {Matikan serial}
        close;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
        comport1.Connected:=false;
        form1.Caption:='Contoh Aplikasi DT-51 Petra Fuzz [Stopping ...]';
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var a: string;
    angka,code  : integer;
    angka1,angka2 : byte;
    b : char;
begin
        a:=edit2.text;          {Ambil data dari edit box}
        val(a,angka,code);      {rubah variabel string ke integer lalu masukkan kedalam variabel angka}
        if angka>255 then
        begin
                angka1:=1;
                angka2:=angka and $00ff;
        end
        else
        begin
                angka1:=0;
                angka2:=angka;
        end;
        comport1.TransmitChar('J');
        comport1.TransmitChar(chr(angka2));             {kirimkan data SP low Byte}
        sleep(1);                                       {delay 1 ms}
        comport1.TransmitChar('K');
        comport1.TransmitChar(chr(angka1));             {kirimkan data SP High Byte}
end;

end.
